Hooks:PostHook(WeaponFactoryTweakData, "init", "StandaloneM16IronSights:init", function (self)
    local insert = table.insert
    local set = table.set

    self.wpn_fps_ass_amcar.adds.wpn_fps_ass_m16_o_handle_sight_mod = deep_clone(self.wpn_fps_ass_amcar.adds.wpn_fps_upg_o_specter)

    -- Adds
    self.parts.wpn_fps_ass_m16_os_frontsight.adds = self.parts.wpn_fps_ass_m16_os_frontsight.adds or {}

    insert(self.parts.wpn_fps_ass_m16_os_frontsight.adds, "wpn_fps_ass_m16_os_gas_tube")

    do -- Forbids
        local list = {
            wpn_fps_ass_m16_o_handle_sight = {
                "wpn_fps_ass_m16_os_frontsight_mod",
                "wpn_fps_m4_uupg_fg_rail_ext_mod",
                "wpn_fps_m4_uupg_fg_rail_ext"
            },
            wpn_fps_amcar_uupg_body_upperreciever = {
                "wpn_fps_ass_m16_os_frontsight_mod"
            },
            wpn_fps_m4_uupg_o_flipup = {
                "wpn_fps_ass_m16_os_frontsight_mod"
            },
            wpn_fps_m4_uupg_fg_rail = {
                "wpn_fps_m4_uupg_fg_rail_ext_mod"
            },
            wpn_fps_upg_ass_m16_fg_stag = {
                "wpn_fps_m4_uupg_fg_rail_ext_mod"
            }
        }

        for part, data in pairs(list) do
            self.parts[part].forbids = self.parts[part].forbids or {}

            local forbids = self.parts[part].forbids
            local cache = set(forbids)

            for i = 1, #data do
                local value = data[i]

                if not cache[value] then
                    insert(forbids, value)
                end
            end
        end

        local function forbid(part, value)
            self.parts[part].forbids = self.parts[part].forbids or {}

            local forbids = self.parts[part].forbids
            local cache = set(forbids)

            if not cache[value] then
                insert(forbids, value)
            end
        end

        local function mirror_forbid(part_1, part_2)
            forbid(part_1, part_2)
            forbid(part_2, part_1)
        end

        mirror_forbid("wpn_fps_m4_uupg_fg_lr300", "wpn_fps_ass_m16_o_handle_sight_mod")
        mirror_forbid("wpn_fps_m4_uupg_fg_lr300", "wpn_fps_ass_m16_os_frontsight_mod")
        mirror_forbid("wpn_fps_m4_uupg_fg_lr300", "wpn_fps_m4_uupg_fg_rail_ext_mod")

        mirror_forbid("wpn_fps_m4_uupg_b_sd", "wpn_fps_ass_m16_o_handle_sight_mod")
        mirror_forbid("wpn_fps_m4_uupg_b_sd", "wpn_fps_ass_m16_os_frontsight_mod")
        mirror_forbid("wpn_fps_m4_uupg_b_sd", "wpn_fps_m4_uupg_fg_rail_ext_mod")
    end

    do -- Overrides
        local function setup_override_table(part, part_to_override)
            self.parts[part].override = self.parts[part].override or {}
            self.parts[part].override[part_to_override] = self.parts[part].override[part_to_override] or {}

            return self.parts[part].override[part_to_override]
        end

        do -- Override Forbids
            local function override_forbid(part, part_to_override, list)
                local overridden_part = setup_override_table(part, part_to_override)
                overridden_part.forbids = overridden_part.forbids or {}
                local overridden_forbids = overridden_part.forbids
                local cache = set(overridden_forbids)
                local forbids = self.parts[part_to_override].forbids

                if forbids then
                    for i = 1, #forbids do
                        local value = forbids[i]

                        if not cache[value] then
                            insert(overridden_forbids, value)

                            cache[value] = true
                        end
                    end
                end

                for i = 1, #list do
                    local value = list[i]

                    if not cache[value] then
                        insert(overridden_forbids, value)
                    end
                end
            end

            local list_1 = {
                "wpn_fps_m4_uupg_b_short",
                "wpn_fps_upg_ass_m4_b_beowulf"
            }

            local list_2 = {
                "wpn_fps_upg_fg_jp",
                "wpn_fps_upg_fg_smr",
                "wpn_fps_upg_ass_m4_fg_lvoa",
                "wpn_fps_upg_ass_m4_fg_moe"
            }

            local list_3 = {
                "wpn_fps_ass_m16_o_handle_sight_mod",
                "wpn_fps_ass_m16_os_frontsight_mod",
                "wpn_fps_m4_uupg_fg_rail_ext_mod"
            }

            for x = 1, #list_1 do
                for y = 1, #list_2 do
                    override_forbid(list_1[x], list_2[y], list_3)
                end
            end

            for x = 1, #list_2 do
                for y = 1, #list_3 do
                    override_forbid(list_2[x], list_3[y], list_1)
                end
            end

            for x = 1, #list_3 do
                for y = 1, #list_1 do
                    override_forbid(list_3[x], list_1[y], list_2)
                end
            end
        end

        do -- Override Attachment Points
            local list = {
                {
                    parts_to_override = {
                        "wpn_fps_ass_m16_os_frontsight",
                        "wpn_fps_ass_m16_os_frontsight_mod",
                        "wpn_fps_ass_m16_os_gas_tube"
                    },
                    attachment_points = {
                        wpn_fps_upg_ass_m16_fg_stag = "a_os_stag",
                        wpn_fps_m4_uupg_fg_rail = "a_gb_frontsight_fg_rail",
                        wpn_fps_upg_fg_jp = "a_gb_frontsight_fg_jp",
                        wpn_fps_upg_fg_smr = "a_gb_frontsight_fg_jp",
                        wpn_fps_upg_ass_m4_fg_lvoa = "a_gb_frontsight_fg_lvoa",
                        wpn_fps_upg_ass_m4_fg_moe = "a_gb_frontsight_fg_lvoa"
                    }
                },
                {
                    parts_to_override = {
                        "wpn_fps_m4_uupg_fg_rail_ext_mod"
                    },
                    attachment_points = {
                        wpn_fps_m16_fg_standard = "a_gb_railed_fg_standard",
                        wpn_fps_m16_fg_railed = "a_gb_railed_fg_railed",
                        wpn_fps_m16_fg_vietnam = "a_gb_railed_fg_standard",
                        wpn_fps_upg_fg_jp = "a_gb_railed_fg_jp",
                        wpn_fps_upg_fg_smr = "a_gb_railed_fg_jp",
                        wpn_fps_upg_ass_m4_fg_lvoa = "a_gb_railed_fg_lvoa",
                        wpn_fps_upg_ass_m4_fg_moe = "a_gb_railed_fg_lvoa"
                    }
                }
            }

            for x = 1, #list do
                local data = list[x]

                for y = 1, #data.parts_to_override do
                    local part_to_override = data.parts_to_override[y]

                    for part, attachment_point in pairs(data.attachment_points) do
                        local overridden_part = setup_override_table(part, part_to_override)

                        overridden_part.a_obj = attachment_point
                    end
                end
            end
        end
    end
end)
